@echo off

rem Update these paths to match your setup, or leave as-is to use the default demo settings.

rem Where to output the alert files, where the Detect server is looking for data.
rem For multi-user setups, this is typically a shared network folder.
set ALERTS_DIR=

rem Note: Only needed if DFM is initialized using xDfmInitializeForLocalUse().
rem In that case, this parameter overrides the (dummy) DeviceID set by DFM.
set DEVICE_ID=

rem The input file (terminal log file) is provided as argument.
set DEVICE_OUTPUT_LOGFILE=

rem Default demo paths
set DEFAULT_ALERTS_DIR=..\test-data\alert-files
set DEFAULT_DEVICE_OUTPUT_LOGFILE=..\test-data\device-log-stm32l4-stopwatch.txt
set DEFAULT_DEVICE_ID=DemoDevice

rem Set ALERTS_DIR to default if not provided
if not defined ALERTS_DIR (
  set "ALERTS_DIR=%DEFAULT_ALERTS_DIR%"
  echo ALERTS_DIR: Using default, %DEFAULT_ALERTS_DIR%
)

rem Set DEVICE_OUTPUT_LOGFILE to default if not provided
if not defined DEVICE_OUTPUT_LOGFILE (
  set "DEVICE_OUTPUT_LOGFILE=%DEFAULT_DEVICE_OUTPUT_LOGFILE%"
  echo DEVICE_OUTPUT_LOGFILE: Using default, %DEFAULT_DEVICE_OUTPUT_LOGFILE%
)

rem Set DEVICE_ID to default if not provided
if not defined DEVICE_ID (
  set "DEVICE_ID=%DEFAULT_DEVICE_ID%"
  echo DEVICE_ID: Using default, %DEFAULT_DEVICE_ID%
)

rem Display settings
echo Percepio Receiver
echo   Reading from: "%DEVICE_OUTPUT_LOGFILE%"
echo   Writing to: "%ALERTS_DIR%"
echo   DeviceID: "%DEVICE_ID%"
echo   Quit using Ctrl-C

rem Execute the Python script with provided or default arguments
python percepio-receiver.py --upload file --folder "%ALERTS_DIR%" --eof wait --deviceid "%DEVICE_ID%" "%DEVICE_OUTPUT_LOGFILE%"
